"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapDifference = exports.mapDifferenceWith = void 0;
function mapDifferenceWith(input, predicate) {
    return (value) => value.filter((sourceValue) => input.findIndex((checkValue) => {
        if (predicate) {
            return predicate(sourceValue, checkValue);
        }
        return sourceValue === checkValue;
    }) === -1);
}
exports.mapDifferenceWith = mapDifferenceWith;
function mapDifference(checkArray, mutate) {
    if (mutate) {
        const checkSet = new Set(checkArray.map(mutate));
        return (value) => [...new Set(value)].filter((x) => !checkSet.has(mutate(x)));
    }
    else {
        const checkSet = new Set(checkArray);
        return (value) => [...new Set(value)].filter((x) => !checkSet.has(x));
    }
}
exports.mapDifference = mapDifference;
//# sourceMappingURL=difference.js.map