"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapIntersection = exports.mapIntersectsWith = void 0;
function mapIntersectsWith(input, predicate) {
    return (value) => {
        return value.filter((sourceValue) => input.findIndex((checkValue) => predicate ? predicate(sourceValue, checkValue) : sourceValue === checkValue) !== -1);
    };
}
exports.mapIntersectsWith = mapIntersectsWith;
function mapIntersection(checkArray, mutate) {
    if (mutate) {
        const checkSet = new Set(checkArray.map(mutate));
        return (value) => [...new Set(value)].filter((x) => checkSet.has(mutate(x)));
    }
    else {
        const checkSet = new Set(checkArray);
        return (value) => [...new Set(value)].filter((x) => checkSet.has(x));
    }
}
exports.mapIntersection = mapIntersection;
//# sourceMappingURL=intersects.js.map